SystemOrganization addCategory: #Objetos3SelfModification!
SystemOrganization addCategory: #'Objetos3SelfModification-Tests'!

Object subclass: #ClassDiff
	instanceVariableNames: 'class1 class2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1
	^ class1! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1: anObject
	class1 := anObject! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2
	^ class2! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2: anObject
	class2 := anObject! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 20:28'!
getDictMethodAndSourceCode: aClass
^ aClass methodDictionary collect: [:i | i getSource ].! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'Sawady 10/27/2012 08:05'!
getMethodDiffBetweenClasses
| methodDictDiff methodDictClass1 methodDictClass2 |
methodDictDiff := Dictionary new.

methodDictClass1 := class1 methodDictionary collect: [:i | i getSource ].
methodDictClass2 := class2  methodDictionary collect: [:i | i getSource ].

(methodDictClass1 associations intersection: methodDictClass2 associations) do: [:x | methodDictDiff add: x ].

^methodDictDiff.
! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'Sawady 10/27/2012 08:03'!
getVarDiffBetweenClasses
^class1 instVarNames intersection: class2 instVarNames.! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 20:19'!
initializeWith: aClass and: anotherClass

self validateSameParentClassFor: aClass and: anotherClass.

class1 := aClass.
class2 := anotherClass.! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'Sawady 11/1/2012 23:41'!
makeDiff: newClassName

| methodDictDiff varsDiff subClassesCollection newRBClass |
 
"Obtengo lo que tienen en comun"

methodDictDiff := self getMethodDiffBetweenClasses.

varsDiff  := self getVarDiffBetweenClasses.

"Creo una clase con las cosas en comun"

newRBClass := RBRefactoring new classObjectFor: newClassName asSymbol.

RBClassRefactoring 
	addClass: newRBClass
	superclass: (class1 superclass)
	subclasses: (OrderedCollection new add: class1; add: class2; yourself)
	category: class1 superclass category.
	
"Le agrego lo que tienen en comun a la clase nueva"
"Le quito lo comun a ambas"

methodDictDiff valuesDo: [ :m | self pullUpMethod: m on: newRBClass].

varsDiff do: [ :v | self pullUpVariable: v on: newRBClass].

"Hago que cuelguen del nuevo padre"

self makeNewSuperClass.! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'Sawady 11/1/2012 23:26'!
refactoringManager
^ RBRefactoringManager instance.! !

!ClassDiff methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 17:46'!
validateSameParentClassFor: aClass and: anotherClass

(aClass superclass = anotherClass superclass) ifFalse: [ 
	Exception new signal: 'The two classes must have the same parent class' ].! !

Object subclass: #Example1
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:14'!
m1
^'m1'! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m2
^'m2'! !

Object subclass: #Example2
	instanceVariableNames: 'v1 v3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m1
^'m1'! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m3
^'m3'! !

TestCase subclass: #ClassDiffTest
	instanceVariableNames: 'classDiff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff
	^ classDiff! !

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff: anObject
	classDiff := anObject! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 10/27/2012 08:06'!
setUp

classDiff := ClassDiff new.
classDiff class1: Example1.
classDiff class2: Example2.! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:32'!
testGetMethodDiffBetweenClasses
	"Tests ClassDiff>>#getMethodDiffBetweenClasses"
	| methodDict |
	methodDict := self classDiff getMethodDiffBetweenClasses.

	self assert: ( methodDict size = 1).
	self assert: ( methodDict keys includesAllOf: (Set with: #m1)).! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:35'!
testGetVarDiffBetweenClasses
	"Tests ClassDiffs>>#getVarDiffBetweenClasses"
	| varDiff |
	varDiff := self classDiff getVarDiffBetweenClasses.
	self assert: varDiff size = 1.
	self assert: (varDiff includesAllOf: (Set with: 'v1'))! !
